<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="工序" prop="type">
       <el-select
              v-model="formData.type"
              placeholder="请选择工序"
              clearable
            >
              <el-option
                v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
      </el-form-item>
      <el-form-item label="名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="单位" prop="unit">
        <el-input v-model="formData.unit" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="上限值" prop="upperVal">
        <el-input v-model="formData.upperVal" placeholder="请输入上限值" />
      </el-form-item>
      <el-form-item label="下限值" prop="lowerVal">
        <el-input v-model="formData.lowerVal" placeholder="请输入下限值" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ZjProductApi, ZjProductVO } from '@/api/mes/zjproduct'
import {DICT_TYPE,getStrDictOptions} from '@/utils/dict'

/** 质量管理-质检参数 表单 */
defineOptions({ name: 'ZjProductForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  type: undefined,
  name: undefined,
  unit: undefined,
  upperVal: undefined,
  lowerVal: undefined,
  remark: undefined,
  productId: undefined,
})
const formRules = reactive({
  type: [{ required: true, message: '工序不能为空', trigger: 'change' }],
  name: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, productId: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.productId = productId
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ZjProductApi.getZjProduct(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ZjProductVO
    if (formType.value === 'create') {
      await ZjProductApi.createZjProduct(data)
      message.success(t('common.createSuccess'))
    } else {
      await ZjProductApi.updateZjProduct(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    type: undefined,
    name: undefined,
    unit: undefined,
    upperVal: undefined,
    lowerVal: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
